﻿using System;
using System.Collections.ObjectModel;
using System.IO;
using System.Linq;
using System.Windows.Forms;
using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.DesktopEdition;
using WinMapSamples.Properties;

namespace WinMapSamples
{
    public partial class Main : Form
    {
        public Main()
        {
            InitializeComponent();
        }

        private void Main_Load(object sender, EventArgs e)
        {
            // set map unit
            winformsMap1.MapUnit = GeographyUnit.DecimalDegree;

            // add overlay
            winformsMap1.Overlays.Add(new WorldMapKitWmsDesktopOverlay());

            ShapeFileFeatureSource citiesFeatureSource = new ShapeFileFeatureSource(@"..\..\App_Data\MajorCities.shp");
            citiesFeatureSource.Open();

             InMemoryMarkerOverlay markerOverlay = new InMemoryMarkerOverlay(citiesFeatureSource.GetColumns());
            Collection<Feature> features = citiesFeatureSource.GetAllFeatures(ReturningColumnsType.NoColumns);
            markerOverlay.FeatureSource.BeginTransaction();
            foreach (Feature feature in features)
            {
                markerOverlay.FeatureSource.AddFeature(feature);
            }
            markerOverlay.FeatureSource.CommitTransaction();
            markerOverlay.MapControl = winformsMap1;

            //FeatureSourceMarkerOverlay markerOverlay = new FeatureSourceMarkerOverlay(citiesFeatureSource);
            //markerOverlay.MapControl = winformsMap1;
            
            markerOverlay.ZoomLevelSet.ZoomLevel01.CustomMarkerStyle = new AnimationMarkerStyle()
            {
                AnimationImage = Resources.animationpoint,
                Width = 20,
                Height = 34,
                YOffset = -17
            };
            markerOverlay.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
            winformsMap1.Overlays.Add(markerOverlay);

            // set map extent
            winformsMap1.CurrentExtent = new RectangleShape(-122.437392, 47.626353, -71.089115, 25.787676);

            winformsMap1.Refresh();
        }
    }
}
